2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
6 # SPDX-License-Identifier: GPL-2.0+
10 # if exiting with 0, write to stdout, else write to stderr
12 [ "${ret}" -eq 1 ] && exec 1>&2
14 Usage: MAKEALL [options] [--] [boards-to-build]
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
36 If no boards are specified, then the default is "powerpc".
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
49 - build all Power Architecture boards:
51 MAKEALL --arch powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
64 echo "** Note: MAKEALL is deprecated - please use buildman instead"
65 echo "** See tools/buildman/README for details"
71 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
72 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
74 # Option processing based on util-linux-2.13/getopt-parse.bash
76 # Note that we use `"$@"' to let each command-line parameter expand to a
77 # separate word. The quotes around `$@' are essential!
78 # We need TEMP as the `eval set --' would nuke the return value of
80 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
83 [ $? != 0 ] && usage 1
85 # Note the quotes around `$TEMP': they are essential!
98 # echo "Option ARCH: argument \`$2'"
99 if [ "$opt_a" ] ; then
100 opt_a="${opt_a%)} || \$2 == \"$2\")"
102 opt_a="(\$2 == \"$2\")"
107 # echo "Option CPU: argument \`$2'"
108 if [ "$opt_c" ] ; then
109 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
111 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
116 # echo "Option SoC: argument \`$2'"
117 if [ "$opt_s" ] ; then
118 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
120 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
125 # echo "Option VENDOR: argument \`$2'"
126 if [ "$opt_v" ] ; then
127 opt_v="${opt_v%)} || \$5 == \"$2\")"
129 opt_v="(\$5 == \"$2\")"
134 # echo "Option BOARD: argument \`$2'"
135 if [ "$opt_b" ] ; then
136 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
138 # We need to check the 7th field too
139 # for boards whose 6th field is "-"
140 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
170 echo "Internal error!" >&2 ; exit 1 ;;
174 GNU_MAKE=$(scripts/show-gnu-make) || {
175 echo "GNU Make not found" >&2
179 # echo "Remaining arguments:"
180 # for arg do echo '--> '"\`$arg'" ; done
182 tools/genboardscfg.py || {
183 echo "Failed to generate boards.cfg" >&2
188 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
189 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
190 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
191 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
192 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
194 if [ "$SELECTED" ] ; then
195 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
197 # Make sure some boards from boards.cfg are actually found
198 if [ -z "$SELECTED" ] ; then
199 echo "Error: No boards selected, invalid arguments"
204 #########################################################################
206 # Print statistics when we exit
210 # Determine number of CPU cores if no default was set
211 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
213 if [ "$BUILD_NCPUS" -gt 1 ]
215 JOBS="-j $((BUILD_NCPUS + 1))"
220 if [ "${MAKEALL_LOGDIR}" ] ; then
221 LOG_DIR=${MAKEALL_LOGDIR}
226 : ${BUILD_NBUILDS:=1}
229 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
231 : ${BUILD_DIR:=./build}
232 mkdir -p "${BUILD_DIR}/ERR"
233 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
238 OUTPUT_PREFIX="${BUILD_DIR}"
240 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
241 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
242 find "${LOG_DIR}/" -type f -exec rm -f {} +
247 # Keep track of the number of builds and errors
258 # Helper funcs for parsing boards.cfg
264 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
268 targets_by_arch() { targets_by_field 2 "$@" ; }
269 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
270 targets_by_soc() { targets_by_field 4 "$@" ; }
272 #########################################################################
274 #########################################################################
276 LIST_5xx="$(targets_by_cpu mpc5xx)"
278 #########################################################################
280 #########################################################################
282 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
284 #########################################################################
286 #########################################################################
288 LIST_512x="$(targets_by_cpu mpc512x)"
290 #########################################################################
292 #########################################################################
294 LIST_8xx="$(targets_by_cpu mpc8xx)"
296 #########################################################################
298 #########################################################################
300 LIST_4xx="$(targets_by_cpu ppc4xx)"
302 #########################################################################
303 ## MPC8260 Systems (includes 8250, 8255 etc.)
304 #########################################################################
306 LIST_8260="$(targets_by_cpu mpc8260)"
308 #########################################################################
309 ## MPC83xx Systems (includes 8349, etc.)
310 #########################################################################
312 LIST_83xx="$(targets_by_cpu mpc83xx)"
314 #########################################################################
315 ## MPC85xx Systems (includes 8540, 8560 etc.)
316 #########################################################################
318 LIST_85xx="$(targets_by_cpu mpc85xx)"
320 #########################################################################
322 #########################################################################
324 LIST_86xx="$(targets_by_cpu mpc86xx)"
326 #########################################################################
328 #########################################################################
349 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
350 # still using "ppc" instead of "powerpc"
355 #########################################################################
357 #########################################################################
359 LIST_SA="$(targets_by_cpu sa1100)"
361 #########################################################################
363 #########################################################################
365 LIST_ARM7="$(targets_by_cpu arm720t)"
367 #########################################################################
369 #########################################################################
371 LIST_ARM9="$(targets_by_cpu arm920t) \
372 $(targets_by_cpu arm926ejs) \
373 $(targets_by_cpu arm946es) \
376 #########################################################################
378 #########################################################################
379 LIST_ARM11="$(targets_by_cpu arm1136) \
380 $(targets_by_cpu arm1176) \
383 #########################################################################
385 #########################################################################
387 LIST_ARMV7="$(targets_by_cpu armv7)"
389 #########################################################################
391 #########################################################################
393 LIST_ARMV8="$(targets_by_cpu armv8)"
395 #########################################################################
397 #########################################################################
399 LIST_at91="$(targets_by_soc at91)"
401 #########################################################################
403 #########################################################################
405 LIST_pxa="$(targets_by_cpu pxa)"
407 #########################################################################
409 #########################################################################
411 LIST_spear="$(targets_by_soc spear)"
413 #########################################################################
415 #########################################################################
417 LIST_arm="$(targets_by_arch arm | \
418 for ARMV8_TARGET in $LIST_ARMV8; \
419 do sed "/$ARMV8_TARGET/d"; \
423 #########################################################################
424 ## MIPS Systems (default = big endian)
425 #########################################################################
427 LIST_mips="$(targets_by_arch mips)"
429 #########################################################################
431 #########################################################################
433 LIST_openrisc="$(targets_by_arch openrisc)"
435 #########################################################################
437 #########################################################################
439 LIST_x86="$(targets_by_arch x86)"
441 #########################################################################
443 #########################################################################
445 LIST_nios2="$(targets_by_arch nios2)"
447 #########################################################################
448 ## MicroBlaze Systems
449 #########################################################################
451 LIST_microblaze="$(targets_by_arch microblaze)"
453 #########################################################################
455 #########################################################################
457 LIST_m68k="$(targets_by_arch m68k)"
458 LIST_coldfire=${LIST_m68k}
460 #########################################################################
462 #########################################################################
464 LIST_avr32="$(targets_by_arch avr32)"
466 #########################################################################
468 #########################################################################
470 LIST_blackfin="$(targets_by_arch blackfin)"
472 #########################################################################
474 #########################################################################
476 LIST_sh2="$(targets_by_cpu sh2)"
477 LIST_sh3="$(targets_by_cpu sh3)"
478 LIST_sh4="$(targets_by_cpu sh4)"
480 LIST_sh="$(targets_by_arch sh)"
482 #########################################################################
484 #########################################################################
486 LIST_sparc="$(targets_by_arch sparc)"
488 #########################################################################
490 #########################################################################
492 LIST_nds32="$(targets_by_arch nds32)"
494 #########################################################################
496 #########################################################################
498 LIST_arc="$(targets_by_arch arc)"
500 #-----------------------------------------------------------------------
502 get_target_location() {
510 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
511 if [ -z "${line}" ] ; then echo "" ; return ; fi
515 CONFIG_NAME="${7%_defconfig}"
517 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
519 if [ $# -gt 5 ]; then
520 if [ "$6" = "-" ] ; then
527 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
528 [ $# -gt 6 ] && [ "$8" != "-" ] && {
535 # Assign board directory to BOARDIR variable
536 if [ "${vendor}" == "-" ] ; then
539 BOARDDIR=${vendor}/${board}
542 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
545 get_target_maintainers() {
546 local name=`echo $1 | cut -d : -f 3`
548 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
549 if [ -z "${line}" ]; then
554 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
555 [ "$mails" == "-" ] && mails=""
562 awk '$7 == "'$target'" { print $2 }' boards.cfg
566 if [ "$PRINT_MAINTS" != 'y' ] ; then
573 local loc=`get_target_location $1`
575 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
577 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
579 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
581 local dir=`echo ${loc} | cut -d ":" -f 2`
582 local cfg=`echo ${loc} | cut -d ":" -f 1`
583 local git_result=`git log --format=%aE board/${dir} \
584 include/configs/${cfg}.h | grep "@"`
585 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
587 local git_result_top=`echo ${git_result} | tr " " "\n" | \
588 sort | uniq -c | sort -nr | head -n 3 | \
589 sed "s/^ \+[0-9]\+ \+//"`
591 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
592 sort -u | tr "\n" " " | sed "s/ $//" ;
594 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
601 # Each finished build will have a file called ${donep}${n},
602 # where n is the index of the build. Each build
603 # we've already noted as finished will have ${skipp}${n}.
604 # The code managing the build process will use this information
605 # to ensure that only BUILD_NBUILDS builds are in flight at once
606 donep="${LOG_DIR}/._done_"
607 skipp="${LOG_DIR}/._skip_"
609 build_target_killed() {
610 echo "Aborted $target build."
611 # Remove the logs for this board since it was aborted
612 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
620 if [ "$ONLY_LIST" == 'y' ] ; then
621 list_target ${target}
625 if [ $BUILD_MANY == 1 ] ; then
626 output_dir="${OUTPUT_PREFIX}/${target}"
627 mkdir -p "${output_dir}"
628 trap build_target_killed TERM
630 output_dir="${OUTPUT_PREFIX}"
633 target_arch=$(get_target_arch ${target})
634 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
635 if [ "${cross_toolchain}" ] ; then
636 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
637 elif [ "${CROSS_COMPILE}" ] ; then
638 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
643 if [ "${output_dir}" != "." ] ; then
644 MAKE="${MAKE} O=${output_dir}"
647 ${MAKE} mrproper >/dev/null
649 echo "Building ${target} board..."
650 ${MAKE} -s ${target}_defconfig >/dev/null
652 ${MAKE} ${JOBS} ${CHECK} all \
653 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
655 # Check for 'make' errors
656 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
660 OBJS=${output_dir}/u-boot
661 if [ -e ${output_dir}/spl/u-boot-spl ]; then
662 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
665 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
667 if [ $BUILD_MANY == 1 ] ; then
672 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
673 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
675 rm ${LOG_DIR}/${target}.ERR
678 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
679 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
680 : $(( ERR_CNT += 1 ))
681 ERR_LIST="${ERR_LIST} $target"
683 : $(( WRN_CNT += 1 ))
684 WRN_LIST="${WRN_LIST} $target"
687 rm ${LOG_DIR}/${target}.ERR
691 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
693 touch "${donep}${build_idx}"
697 search_idx=${OLDEST_IDX}
698 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
701 if [ -e "${donep}${search_idx}" ] ; then
702 : $(( CURRENT_CNT-- ))
703 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
704 : $(( OLDEST_IDX++ ))
706 # Only want to count it once
707 rm -f "${donep}${search_idx}"
708 touch "${skipp}${search_idx}"
709 elif [ -e "${skipp}${search_idx}" ] ; then
710 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
711 : $(( OLDEST_IDX++ ))
713 : $(( search_idx++ ))
714 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
715 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
716 search_idx=${OLDEST_IDX}
727 # If a LIST_xxx var exists, use it. But avoid variable
728 # expansion in the eval when a board name contains certain
729 # characters that the shell interprets.
732 *) list=$(eval echo '${LIST_'$t'}') ;;
734 if [ -n "${list}" ] ; then
735 build_targets ${list}
737 : $((TOTAL_CNT += 1))
738 : $((CURRENT_CNT += 1))
739 rm -f "${donep}${TOTAL_CNT}"
740 rm -f "${skipp}${TOTAL_CNT}"
741 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
743 touch "${donep}${TOTAL_CNT}"
744 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
746 touch "${donep}${TOTAL_CNT}"
748 if [ $BUILD_MANY == 1 ] ; then
749 build_target ${t} ${TOTAL_CNT} &
752 build_target ${t} ${TOTAL_CNT}
758 # We maintain a running count of all the builds we have done.
759 # Each finished build will have a file called ${donep}${n},
760 # where n is the index of the build. Each build
761 # we've already noted as finished will have ${skipp}${n}.
762 # We track the current index via TOTAL_CNT, and the oldest
763 # index. When we exceed the maximum number of parallel builds,
764 # We look from oldest to current for builds that have completed,
765 # and update the current count and oldest index as appropriate.
766 # If we've gone through the entire list, wait a second, and
767 # reprocess the entire list until we find a build that has
769 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
775 #-----------------------------------------------------------------------
782 # Mac OS X is known to have BSD style ps
783 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
784 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
787 # everything else tries the GNU style
788 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
789 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
793 kill $children 2> /dev/null
794 wait $children 2> /dev/null
800 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
802 # Only count boards that completed
803 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
805 rm -f ${donep}* ${skipp}*
807 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
808 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
809 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
810 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
811 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
812 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
813 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
815 # Remove the logs for any board that was interrupted
816 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
819 : $((TOTAL_CNT -= ${SKIP_CNT}))
821 echo "--------------------- SUMMARY ----------------------------"
822 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
823 echo "Boards skipped: ${SKIP_CNT}"
825 echo "Boards compiled: ${TOTAL_CNT}"
826 if [ ${ERR_CNT} -gt 0 ] ; then
827 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
829 if [ ${WRN_CNT} -gt 0 ] ; then
830 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
832 echo "----------------------------------------------------------"
834 if [ $BUILD_MANY == 1 ] ; then
843 #-----------------------------------------------------------------------
845 # Build target groups selected by options, plus any command line args
846 set -- ${SELECTED} "$@"
847 # run PowerPC by default
848 [ $# = 0 ] && set -- powerpc